##AIM : 
###Design and construct a suitable circuit and determine the drain characteristics and transconductance  characteristics of an enhancement mode MOSFET.

##COMPONENTS REQUIRED: 
 MOSFET (1RF 740), Resistor (1k ohm), Voltmeters (0-30V range and 0-10V range), Ammeter (0- 25mA range) and Regulated power supply (2 nos.  variable power supply)

##CIRCUIT DIAGRAM:
  ![E-Mos](mos1.png)
###Fig.1a.Depletion mode(negative gate voltage)  1b. Enhancement mode (positive gate voltage) 

##Sample Characteristics to be obtained
   ![E-Mos](mos2.png)
###Fig. 2a. Drain Characteristics and b. Transconductance (or mutual/transfer) characteristics

##PROCEDURE :
1.	Make the connections as shown in the corresponding circuit diagram. Special care to be taken in connecting the voltmeters and ammeters according to the polarity shown in circuit diagram figures.
2.	Repeat the procedure for finding drain and transconductance characteristics for both modes, that is for both depletion and enhancement modes.
3.	Tabulate the readings in separate tabular columns as shown below.
4.	Plot the drain characteristics (ID versus VDS for different values of gate voltages VGS) of both modes (that is, depletion and enhancement) in one plot as shown below. (Take ID along the Y-axis and VDS along the X-axis in the plot)
5.	From this plot of drain characteristics find the drain resistance rd=(delta)Vds/(delta)Id  , which is shown in Fig. 2a.
6.	Similarly plot the transconductance characteristics of both modes in one plot, with ID along the Y-axis and VGS along the X-axis in the graph for one value of VDS, say VDS = 5V.
7.	From this plot find the mutual conductance or transconductance gm = (delta)Id/Vgs(delta) (Fig. 2b).
8. 	Lastly find the amplification factor,u=rd*gm.

##Procedure for finding the Transconductance Characteristics in both modes:

1.	Switch on the power supplies, with both V2 and V1 at zero voltage.
2.	Initially set V1 =VGS = 0V. Now set V2 = VDS = 5V (say). Vary the power supply V1 i.e., VGS and note down the corresponding current ID (in mA) (Simultaneously note down the VGS value from the voltmeter connected at the gate terminal).
3.	Repeat the above procedure for a different value of VDS, say 10V.

Note: In the above procedure VDS (i.e., the power supply V2) is kept constant and the power supply V1 (=VGS) is varied.

###Drain Characteristics :

1.	Initially set V1 = VGS =3.5V (say), slowly vary V2 and note down the corresponding current ID. Simultaneously note down in the tabular column the voltmeter reading VGS. 
2.	Repeat the above procedure for different values of VGS and note down the current ID for corresponding V1 = VDS.  
3.	Plot the graph of ID versus VDS for different values of gate voltages.

Note: In the above procedure VDS (i.e., the power supply V2) is varied and the power supply V1 (=VGS) is kept constant.

##READINGS TABULATED IN TABULAR COLUMN
Depletion mode (Note: In this mode VGS values are all negative and the minus sign to be appended to the readings, though the voltmeter at the gate terminal shows the deflection in the same way for both modes)
###   Drain Characteristics                                            Transconductance Characteristics
   ![E-Mos](mos3.png)

##Enhancement mode readings
###Drain Characteristics                                            Transconductance Characteristics
 
  ![E-Mos](mos4.png)